/************************************************************************************
 Z21 Ethernet DCC Command Station Interface config file 
 Copyright (c) 2015-2021 by Philipp Gahtow 
***********************************************************************************/

/*-------------**********************************-----------------------------------
/ ************* CHANGE DOWN HERE THE CONFIGURATION ***************
/ -------------**********************************-----------------------------------*/
/* Command Station Config: */
/* => uncomment ("//" or #undef) the following lines, if you not USE the Interface! */
/*----------------------------------------------------------------------------------*/

/***************************************************************

 S88 Bus Interface 

***************************************************************/

/* activate singel line S88N Interface (max 62 * 8 Module)*/
#define S88N

/**************************************************************
OLED Display Activation*/
//#define OLED
/***************************************************************
 
  Z21 LAN WiFi Interface für Arduino UNO/MEGA/DUE (ESP 8266)
 
**************************************************************/

/* activate WLAN Z21 Komunikation via Serial to ESP8266 */
#define WIFI

/* use not the standard WLAN Serial Interface. Select another serial: */
#define WLAN Serial3

/* WiFi over SoftSerial for UNO only! - LAN and LocoNet will be inaktiv! */
//#define Z21VIRTUAL  


/***************************************************************

 Config for stand alone ESP8266 or ESP32 Board Z21 Central Station

***************************************************************/

/* Website to configure IP Adress and Hotsport settings (only ESP8266 central) */
#define ESP_HTTPCONF  

/* Change default Z21 AP (SSID) */
#define SssidAP "Z21_ESP"   

/* Change default Z21 network password */
#define SpassAP "12345678"  

/* Change default Kanal des AP */
#define SkanalAP 12          



/**************************************************************

 LAN W5100 Ethernet Z21 LAN Kommunikation

***************************************************************/

/* Aktivieren des Ethernet LAN Interface */
//#define LAN       //Standard IP ist 192.168.0.111. Bitte diese IP nur über die Webseite (http://192.168.0.111) ändern!

/* USE a ENC28J60 module - instead of w5100 Shield (for MEGA only!) */
//#define ENC28   

/* Activate to Receive a IP Adress from the DHCP Server, if no DHCP found fix IP Adress vom EEPROM will be load.*/
//#define DHCP      

/* Website to configure IP Adress and Number of S88 Bus Module*/
#define HTTPCONF  

/* change optional LAN MAC Address. MAC starts with: „84:2B:BC:..Byte*2..:..Byte*1..:..Byte*0..“*/
//#define LANmacB2 0xEF   //Byte2
//#define LANmacB1 0xFE   //Byte1
//#define LANmacB0 0xED   //Byte0

/* Timeout to wait for a DHCP respose (Fix default Time: 2 sec) */
//#define LANTimeoutDHCP 10000 


/***************************************************************

 DCC RailCom Global Detector

***************************************************************/

/* activate the DCC Railcom Global Detector for MEGA on Serial Port 3 (RX only) */
//#define DCCGLOBALDETECTOR  


/***************************************************************

 XpressNet Master/Salve Interface

***************************************************************/

/* activate the XpressNet Interface */
#define XPRESSNET 


/***************************************************************

 LocoNet Interface 
 (Timer1, Timer5 on MEGA)

***************************************************************/

/* activate the LocoNet Interface */
//#define LOCONET  

/* LocoNet Master-Mode: provide a Slot Server for Loco to use FRED */
//#define LnSLOTSRV                 

/* sende alle Lok-Ereignisse ins LocoNet (MASTER-MODE only) - default: false*/
//#define TXAllLokInfoOnLN true    


/***************************************************************

 External Booster Interface
 (zB. ROCO, CD[E])

***************************************************************/

/* activate external Booster support */
#define BOOSTER_EXT


/***************************************************************

 internal Booster Interface
 (zB. TLE5206)

***************************************************************/

/* activate internal Booster support */
#define BOOSTER_INT

/*(VAmpIntPin) activate the current sensor for prog track:*/
#define BOOSTER_INT_MAINCURRENT   //MEGA, SANGUINO and for UNO only without external Booster

/*(VAmpIntPin) activate SHORT CIRCUIT SENCE over MAINCURRENT*/
#define BOOSTER_INT_CURRENT_SHORT_DETECT     //alternativ Short Circuit Detection over current sence resistor

/* Time after internal short circuit is detected (Fix default Value = 3) */
#define DetectShortCircuit_INT  3
  
/* analogRead value for "mA" that is too much (Fix default Value = 400) */
#define DETECT_SHORT_INT_VALUE  400


/***************************************************************

 DCC Interface Configuration

***************************************************************/

/* default speed steps (Fahrstufen) => possible values are: FS14, FS28, FS128 */
#define FS128   

/* Define accessory Address start value (default ROCO) => possivle values are: ROCO (+0), IB (+4) */
//#define SwitchFormat IB   


/***************************************************************/
/*-------------------------------------------------------------*/
/*------------------DEBUG-ONLY---------------------------------*/
/*-------------------------------------------------------------*/
/***************************************************************/

/* Activate Debug on "Serial" with speed setting! */
#define DebugBaud 115200 

/* use not the Default Standard Debug Serial Interface. Select another serial: */
//#define Debug Serial3

/*---------- select what to show: --------------*/
#define DEBUG    //To see System-DATA on Serial
#define REPORT    //To see Sensor Messages (LocoNet & S88)
//#define LnDEB    //To see RAW DATA of LocoNet Protokoll
#define XnDEB    //To see XpressNet
#define Z21DEBUG //to see Z21 LAN control data
//#define Z21DATADEBUG //to see RAW DATA of Z21 LAN Protokoll
//#define Z21SYSTEMDATADEBUG  //to see the system data mainpower and temp
#define DEBUG_WLAN_CONFIG  //to see config data of Wifi ESP8266 (IP, Pw, ..)
//#define RCDEB     //To see RailCom Data
//#define ESP32I2CDEBUG  //to see communication to CoMCU over I2C


/***************************************************************/
/*-------------------------------------------------------------*/
/*-------------------Experimental-ONLY-------------------------*/
/*-------------------------------------------------------------*/
/***************************************************************/

/*Dallas 18B20 Temperatur Sendor */
//#define DALLASTEMPSENSE //Block Programm while running!

/*DCC Decoder (only for MEGA, To decode a DCC-Signal, add this data to command station DCC output)*/
//#define DECODER   //outdated-not in use anymore!!!
